﻿@page "/schedule"
@inject IJSRuntime JSRuntime
@using ThermoSjck_ServerApp.Model
@using MongoDB.Driver
@using ThermoSjck_ServerApp.Services
@using Microsoft.Extensions.Configuration 
@inject IConfiguration Configuration 
<PageTitle>Schedule</PageTitle>



<h2>Weekprofile</h2>

<p>Default temperature: 22°C</p>

<table border="1">

    <tr>

        <th>Day</th>

        <th>Time</th>

        <th>Temperature (°C)</th>

        <th>Add Entry</th>

    </tr>

    @foreach (var row in rows)

    {

        <tr>

            <td>@row.DayOfWeek</td>

            <td>

                <select id="@row.HourId" @bind="row.SelectedHour">

                    @for (int j = 0; j < 24; j++)

                    {

                        <option value="@j.ToString("D2")">@j.ToString("D2")</option>

                    }

                </select>

                <select id="@row.MinuteId" @bind="row.SelectedMinute">

                    <option value="00">00</option>

                    <option value="15">15</option>

                    <option value="30">30</option>

                    <option value="45">45</option>

                </select>

            </td>

            <td><input type="text" id="@row.TemperatureId" @bind="row.SelectedTemperature" /></td>

            <td><button @onclick="() => AddRow(row)">Add</button></td>

        </tr>

    }

</table>

<ul>

    @foreach (var entry in entries)

    {

        var time = new DateTime(1, 1, 1, int.Parse(entry.Hour), int.Parse(entry.Minute), 0);

        <li>@entry.DayOfWeek, @time.ToString("HH:mm"), @entry.Temperature°C</li>

    }

</ul>


@code {

    private class Row

    {

        public string DayOfWeek { get; set; }

        public string HourId { get; set; }

        public string MinuteId { get; set; }

        public string TemperatureId { get; set; }

        public string SelectedHour { get; set; } = "00";

        public string SelectedMinute { get; set; } = "00";

        public string SelectedTemperature { get; set; }

    }

    private class Entry

    {

        public string DayOfWeek { get; set; }

        public string Hour { get; set; }

        public string Minute { get; set; }

        public string Temperature { get; set; }

    }

    private List<Row> rows = new List<Row>

    {

        new Row { DayOfWeek = "Monday", HourId = "monday-hour", MinuteId = "monday-minute", TemperatureId = "monday-temperature" },

        new Row { DayOfWeek = "Tuesday", HourId = "tuesday-hour", MinuteId = "tuesday-minute", TemperatureId = "tuesday-temperature" },

        new Row { DayOfWeek = "Wednesday", HourId = "wednesday-hour", MinuteId = "wednesday-minute", TemperatureId = "wednesday-temperature" },

        new Row { DayOfWeek = "Thursday", HourId = "thursday-hour", MinuteId = "thursday-minute", TemperatureId = "thursday-temperature" },

        new Row { DayOfWeek = "Friday", HourId = "friday-hour", MinuteId = "friday-minute", TemperatureId = "friday-temperature" },

        new Row { DayOfWeek = "Saturday", HourId = "saturday-hour", MinuteId = "saturday-minute", TemperatureId = "saturday-temperature" },

        new Row { DayOfWeek = "Sunday", HourId = "sunday-hour", MinuteId = "sunday-minute", TemperatureId = "sunday-temperature" },

    };

    private List<Entry> entries = new List<Entry>();

    private void AddRow(Row row)

    {

        var hour = row.SelectedHour;

        var minute = row.SelectedMinute;

        var temperature = row.SelectedTemperature;

        var dayOfWeek = row.DayOfWeek;

        // Überprüfung der Zeile

        var existingEntry = entries.FirstOrDefault(e => e.DayOfWeek == dayOfWeek && e.Hour == hour && e.Minute == minute);

        if (existingEntry == null)

        {

            entries.Add(new Entry

                {

                    DayOfWeek = dayOfWeek,

                    Hour = hour,

                    Minute = minute,

                    Temperature = temperature

                });

            // Zurücksetzen der Eingabe in der Zeile

            row.SelectedHour = "00";

            row.SelectedMinute = "00";

            row.SelectedTemperature = "";

            StateHasChanged();

        }

        else

        {

            JSRuntime.InvokeAsync<object>("alert", "This day and time already added.");

        }

    }

}